---
title: CanvasRenderingContext2D.shadowBlur
slug: Web/API/CanvasRenderingContext2D/shadowBlur
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Property
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.shadowBlur</code></strong> property of the Canvas 2D API specifies the amount of blur applied to shadows. The default is <code>0</code> (no blur).</p>

<div class="notecard note">
<p><strong>Note:</strong> Shadows are only drawn if the {{domxref("CanvasRenderingContext2D.shadowColor", "shadowColor")}} property is set to a non-transparent value. One of the <code>shadowBlur</code>, {{domxref("CanvasRenderingContext2D.shadowOffsetX", "shadowOffsetX")}}, or {{domxref("CanvasRenderingContext2D.shadowOffsetY", "shadowOffsetY")}} properties must be non-zero, as well.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.shadowBlur = <em>level</em>;
</pre>

<dl>
 <dt><code>level</code></dt>
 <dd>A non-negative float specifying the level of shadow blur, where <code>0</code> represents no blur and larger numbers represent increasingly more blur. This value doesn't correspond to a number of pixels, and is not affected by the current transformation matrix. The default value is <code>0</code>. Negative, {{jsxref("Infinity")}}, and {{jsxref("NaN")}} values are ignored.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Adding_a_shadow_to_a_shape">Adding a shadow to a shape</h3>

<p>This example adds a blurred shadow to a rectangle. The <code>shadowColor</code> property sets its color, and <code>shadowBlur</code> sets its level of bluriness.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[6]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Shadow
ctx.shadowColor = 'red';
ctx.shadowBlur = 15;

// Rectangle
ctx.fillStyle = 'blue';
ctx.fillRect(20, 20, 150, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Adding_a_shadow_to_a_shape', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-shadowblur", "CanvasRenderingContext2D.shadowBlur")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.shadowBlur")}}</p>

<h3 id="WebKitBlink-specific_notes">WebKit/Blink-specific notes</h3>

<p>In WebKit- and Blink-based browsers, the non-standard and deprecated method <code>ctx.setShadow()</code> is implemented besides this property.</p>

<pre class="brush: js">setShadow(width, height, blur, color, alpha);
setShadow(width, height, blur, graylevel, alpha);
setShadow(width, height, blur, r, g, b, a);
setShadow(width, height, blur, c, m, y, k, a);
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this property: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasRenderingContext2D.shadowColor")}}</li>
</ul>
